diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index bfcf947..30a8c84 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -555,7 +555,7 @@ DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId,
 	char		relname[NAMEDATALEN];
 	Oid			namespaceId;
 	Oid			relationId;
-	Oid			tablespaceId;
+	Oid			tablespaceId = InvalidOid;
 	Relation	rel;
 	TupleDesc	descriptor;
 	List	   *inheritOids;
@@ -681,7 +681,8 @@ DefineRelation(CreateStmt *stmt, char relkind, Oid ownerId,
 		Assert(list_length(inheritOids) == 1);
 		tablespaceId = get_rel_tablespace(linitial_oid(inheritOids));
 	}
-	else
+
+	if (!OidIsValid(tablespaceId))
 		tablespaceId = GetDefaultTablespace(stmt->relation->relpersistence,
 											partitioned);
 
